package com.javacodegeeks.examples.jaxws.handler;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.ws.LogicalMessage;
import javax.xml.ws.handler.LogicalHandler;
import javax.xml.ws.handler.LogicalMessageContext;
import javax.xml.ws.handler.MessageContext;

import com.javacodegeeks.examples.jaxws.GetStateCapitalRequest;
import com.javacodegeeks.examples.jaxws.ObjectFactory;

public class StateHandler implements LogicalHandler<LogicalMessageContext> {

	@Override
	public boolean handleMessage(LogicalMessageContext context) {
		boolean outbound = (Boolean)
	             context.get (MessageContext.MESSAGE_OUTBOUND_PROPERTY);
		if (!outbound) {
			System.out.println("\nInbound message:");
           LogicalMessage msg = context.getMessage(); 
           JAXBContext jaxbContext = null;
           try {
				jaxbContext = JAXBContext.newInstance(ObjectFactory.class);
               Object payload = msg.getPayload(jaxbContext); 
               if (payload instanceof JAXBElement) {
                   Object obj = ((JAXBElement)payload).getValue();
                   System.out.println("payload:"+payload.getClass().getName());
                   GetStateCapitalRequest request = (GetStateCapitalRequest) obj;
                   String stateUC = request.getState().toUpperCase();
                   request.setState(stateUC);
                   ((JAXBElement)payload).setValue(request);
                   msg.setPayload(payload, jaxbContext);
               }             	
			} catch (JAXBException e) {
				e.printStackTrace();
			}
		} else {
           System.out.println("\nOutbound message:");
		}
		return true;
	}

	@Override
	public boolean handleFault(LogicalMessageContext context) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void close(MessageContext context) {
		// TODO Auto-generated method stub
		
	}

}
