package com.javacodegeeks.examples.jaxws.impl;

import java.util.HashMap;
import java.util.Map;

import javax.jws.HandlerChain;

import com.javacodegeeks.examples.jaxws.GetStateCapitalRequest;
import com.javacodegeeks.examples.jaxws.GetStateCapitalResponse;
import com.javacodegeeks.examples.jaxws.StateCapitalPortType;

@HandlerChain(file = "handlers.xml")
public class StateCapitalWSImpl implements StateCapitalPortType {

Map<String, String> stateDataMap = new HashMap<>();
	
	public StateCapitalWSImpl() {
		init();
	}

	private void init() {
		stateDataMap.put("AL", "Montgomery");
		stateDataMap.put("CO", "Denver");
		stateDataMap.put("GA", "Atlanta");
		
	}

	@Override
	public GetStateCapitalResponse getStateCapital(GetStateCapitalRequest parameters) {
		String state = parameters.getState();
		String capital = stateDataMap.get(state);
		GetStateCapitalResponse response = new GetStateCapitalResponse();
		response.setCity(capital);
		return response;
	}

}
